#include "stdio.h"
#include "string.h"
#include "stdbool.h"
#include "stdlib.h"

void pointer_samples(void) {
  int a[10] = {1, 2, 3, -4, 5, 6, 7, 8, 9 , 10};

  int* p;

  // an int array is compatible with a int*

  p = a;

  printf("a[0] = %d; *p = %d\n", a[0], *p);

  int* q = p + 3;
  printf("a[3] = %d; *q = %d\n", a[3], *q);

  printf("*(p+3) = %d; *p+3 = %d\n", *(p+3), *p+3);

  printf("die Werte der Zeiger: p=%p und q=%p\n",
	 p, q);

  printf("Abstand von q und p = %ld\n", q - p);

  int v = 42;
  int* ip = &v;
  printf("Vorher: v= %d\n", v);
  *ip = 666;
  printf("Nachher: v= %d\n", v);

  ip = &a[9];
  printf ("Vorher: a[9] = %d\n", a[9]);
  *ip = 4711;
  printf ("Nachher: a[9] = %d\n", a[9]);
  
  
}

void string_samples(void) {
  const char* t1 = "encrypted";
  const char* t2 = "encrypted";
  
  printf ("ein stringvergleich... %d\n",
	  t1 == t2); // anti pattern!

  char a1[] = "encrypted";
  char a2[] = "encrypted";

  /*
    printf ("noch ein stringvergleich... %d\n",
	  a1 == a2); // warning!
  */

  printf ("korrekter stringvergleich... %d, %d, %d\n",
	  strcmp(t1, t2), strcmp (a1, a2),
	  strcmp ("encrypted", "encrypted"));
}

void null_samples(void) {
  int * p = NULL;
  *p = 999; // --> segmentation fault
}

struct person {
  char * name;
  unsigned int age;
};


void struct_samples(void) {
  struct person johnny = {"Johnny Depp", 57};
  struct person *mary = malloc(sizeof(struct person));
  mary->name = "Mary Roos";
  mary->age = 99;

  printf("my name is %s and I'm %u years old.\n",
	 johnny.name, johnny.age);
  printf("my name is %s and I'm %u years old.\n",
	 mary->name, mary->age);
  free(mary);
}

int main(void) {
  pointer_samples();
  string_samples();
  /* null_samples(); */
  struct_samples();
}
